/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: FreeMindApplet.java,v 1.18 2004/02/02 21:25:24 christianfoltin Exp $*/

package freemind.main;

import freemind.view.mindmapview.MapView;
import freemind.controller.MenuBar;
import freemind.controller.Controller;
import java.io.InputStream;
import java.io.File;
import java.net.URL;
import java.util.Properties;
import java.util.ResourceBundle;
import java.util.PropertyResourceBundle;
import java.util.Enumeration;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Cursor;
import javax.swing.*;

public class FreeMindApplet extends JApplet implements FreeMindMain {

    public static final String version = "0.7.1";
    //    public static final String defaultPropsURL;
    public URL defaultPropsURL;
    public static Properties defaultProps;
    public static Properties userProps;
    private JScrollPane scrollPane = new JScrollPane();
    private MenuBar menuBar;
    private PropertyResourceBundle resources;
    private JLabel status = new JLabel();
    Controller c;//the one and only controller


    public FreeMindApplet() {/*_I*/_prof.prof.cnt[482]++;/*I_*/
    }//Constructor

    public boolean isApplet() {/*_I*/_prof.prof.cnt[483]++;/*I_*/
       /*_I*/{_prof.prof.cnt[484]++;/*I_*/return true;/*_I*/}/*I_*/ }

    public File getPatternsFile() {/*_I*/_prof.prof.cnt[485]++;/*I_*/
       /*_I*/{_prof.prof.cnt[486]++;/*I_*/return null;/*_I*/}/*I_*/ }

    public Controller getController() {/*_I*/_prof.prof.cnt[487]++;/*I_*/
	/*_I*/{_prof.prof.cnt[488]++;/*I_*/return c;/*_I*/}/*I_*/
    }

    public MapView getView() {/*_I*/_prof.prof.cnt[489]++;/*I_*/
	/*_I*/{_prof.prof.cnt[490]++;/*I_*/return c.getView();/*_I*/}/*I_*/
    }

    public void setView(MapView view) {/*_I*/_prof.prof.cnt[491]++;/*I_*/
 	/*_I*/{_prof.prof.cnt[492]++;/*I_*/scrollPane.setViewportView(view);/*_I*/}/*I_*/
    }

    public MenuBar getFreeMindMenuBar() {/*_I*/_prof.prof.cnt[493]++;/*I_*/
	/*_I*/{_prof.prof.cnt[494]++;/*I_*/return menuBar;/*_I*/}/*I_*/
    }

    public Container getViewport() {/*_I*/_prof.prof.cnt[495]++;/*I_*/
		/*_I*/{_prof.prof.cnt[496]++;/*I_*/return scrollPane.getViewport();/*_I*/}/*I_*/
    }

    public String getFreemindVersion() {/*_I*/_prof.prof.cnt[497]++;/*I_*/
        /*_I*/{_prof.prof.cnt[498]++;/*I_*/return version;/*_I*/}/*I_*/
    }

    // "dummy" implementation of the interface (PN)
    public int getWinHeight() {/*_I*/_prof.prof.cnt[499]++;/*I_*/
      /*_I*/{_prof.prof.cnt[500]++;/*I_*/return getRootPane().getHeight();/*_I*/}/*I_*/
    }
    public int getWinWidth() {/*_I*/_prof.prof.cnt[501]++;/*I_*/
      /*_I*/{_prof.prof.cnt[502]++;/*I_*/return getRootPane().getWidth();/*_I*/}/*I_*/
    }
    public int getWinState() {/*_I*/_prof.prof.cnt[503]++;/*I_*/
      /*_I*/{_prof.prof.cnt[504]++;/*I_*/return 6;/*_I*/}/*I_*/  
    }

    /**
     * Returns the ResourceBundle with the current language
     */
    public ResourceBundle getResources() {/*_I*/_prof.prof.cnt[505]++;/*I_*/
	/*_I*/{_prof.prof.cnt[506]++;/*I_*/if (resources==null) {
	    /*_I*/_prof.prof.cnt[507]++;/*I_*/String lang = userProps.getProperty("language");
	    /*_I*/{_prof.prof.cnt[508]++;/*I_*/try {
		/*_I*/_prof.prof.cnt[509]++;/*I_*/URL myurl = getResource("Resources_"+lang.trim()+".properties");
		/*_I*/_prof.prof.cnt[510]++;/*I_*/InputStream in = myurl.openStream();
		/*_I*/{_prof.prof.cnt[511]++;/*I_*/resources = new PropertyResourceBundle(in);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[512]++;/*I_*/in.close();/*_I*/}/*I_*/
	    } catch (Exception ex) {
		/*_I*/{_prof.prof.cnt[513]++;/*I_*/System.err.println("Error loading Resources");/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[514]++;/*I_*/return null;/*_I*/}/*I_*/
	    }/*_I*/}/*I_*/
	}/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[515]++;/*I_*/return resources;/*_I*/}/*I_*/
    }

    public String getProperty(String key) {/*_I*/_prof.prof.cnt[516]++;/*I_*/
	/*_I*/{_prof.prof.cnt[517]++;/*I_*/return userProps.getProperty(key);/*_I*/}/*I_*/
    }
    
    public void setProperty(String key, String value) {/*_I*/_prof.prof.cnt[518]++;/*I_*/
    }

    public String getFreemindDirectory() {/*_I*/_prof.prof.cnt[519]++;/*I_*//*_I*/{_prof.prof.cnt[520]++;/*I_*/return null;/*_I*/}/*I_*/};

    static int iMaxNodeWidth = 0;
	
    static public int getMaxNodeWidth(){/*_I*/_prof.prof.cnt[521]++;/*I_*/
       /*_I*/{_prof.prof.cnt[522]++;/*I_*/if (iMaxNodeWidth == 0){
          /*_I*/{_prof.prof.cnt[523]++;/*I_*/try{
             /*_I*/{_prof.prof.cnt[524]++;/*I_*/iMaxNodeWidth = Integer.parseInt(userProps.getProperty("max_node_width"));/*_I*/}/*I_*/	
          }
          catch (NumberFormatException nfe) {
             /*_I*/{_prof.prof.cnt[525]++;/*I_*/iMaxNodeWidth = Integer.parseInt(userProps.getProperty("el__max_default_window_width"));/*_I*/}/*I_*/
          }/*_I*/}/*I_*/
       }/*_I*/}/*I_*/
       /*_I*/{_prof.prof.cnt[526]++;/*I_*/return iMaxNodeWidth;/*_I*/}/*I_*/
    }

    public void saveProperties() {/*_I*/_prof.prof.cnt[527]++;/*I_*/
    }

    public void setTitle(String title) {/*_I*/_prof.prof.cnt[528]++;/*I_*/
    }

    public void out (String msg) {/*_I*/_prof.prof.cnt[529]++;/*I_*/
	/*_I*/{_prof.prof.cnt[530]++;/*I_*/status.setText(msg);/*_I*/}/*I_*/
    }

    public void err (String msg) {/*_I*/_prof.prof.cnt[531]++;/*I_*/
	/*_I*/{_prof.prof.cnt[532]++;/*I_*/status.setText("ERROR: "+msg);/*_I*/}/*I_*/
    }

    public void openDocument(URL doc) throws Exception {/*_I*/_prof.prof.cnt[533]++;/*I_*/
	/*_I*/{_prof.prof.cnt[534]++;/*I_*/getAppletContext().showDocument(doc,"_blank");/*_I*/}/*I_*/
    }

    public void start() {/*_I*/_prof.prof.cnt[535]++;/*I_*/
       // Make sure the map is centered at the very beginning.
       /*_I*/{_prof.prof.cnt[536]++;/*I_*/try {
          /*_I*/{_prof.prof.cnt[537]++;/*I_*/if (getView() != null) {
             /*_I*/{_prof.prof.cnt[538]++;/*I_*/getView().moveToRoot();/*_I*/}/*I_*/ }
          else {
             /*_I*/{_prof.prof.cnt[539]++;/*I_*/System.err.println("View is null.");/*_I*/}/*I_*/ }/*_I*/}/*I_*/}
       catch (Exception e) { /*_I*/{_prof.prof.cnt[540]++;/*I_*/e.printStackTrace();/*_I*/}/*I_*/ }/*_I*/}/*I_*/
    }

   /*
    public void stop() {
    }

    public void destroy() {
    }
    */

    public void setWaitingCursor(boolean waiting) {/*_I*/_prof.prof.cnt[541]++;/*I_*/
       /*_I*/{_prof.prof.cnt[542]++;/*I_*/if (waiting) {
          /*_I*/{_prof.prof.cnt[543]++;/*I_*/getRootPane().getGlassPane().setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));/*_I*/}/*I_*/
          /*_I*/{_prof.prof.cnt[544]++;/*I_*/getRootPane().getGlassPane().setVisible(true);/*_I*/}/*I_*/ }
       else {
          /*_I*/{_prof.prof.cnt[545]++;/*I_*/getRootPane().getGlassPane().setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));/*_I*/}/*I_*/
          /*_I*/{_prof.prof.cnt[546]++;/*I_*/getRootPane().getGlassPane().setVisible(false);/*_I*/}/*I_*/ }/*_I*/}/*I_*/}

    public URL getResource(String name) {/*_I*/_prof.prof.cnt[547]++;/*I_*/
	/*_I*/{_prof.prof.cnt[548]++;/*I_*/return this.getClass().getResource("/"+name);/*_I*/}/*I_*/
    }

    public java.util.logging.Logger getLogger(String forClass) {/*_I*/_prof.prof.cnt[549]++;/*I_*/
        /* Applet logging is anonymous due to security reasons. (Calling a named logger is answered with a security exception).*/
        /*_I*/{_prof.prof.cnt[550]++;/*I_*/return java.util.logging.Logger.getAnonymousLogger();/*_I*/}/*I_*/
    }

    public void init() {/*_I*/_prof.prof.cnt[551]++;/*I_*/
	/*_I*/_prof.prof.cnt[552]++;/*I_*/JRootPane rootPane = createRootPane();
 	//load properties
	/*_I*/{_prof.prof.cnt[553]++;/*I_*/defaultPropsURL = getResource("freemind.properties");/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[554]++;/*I_*/try {
	    //load properties
	    /*_I*/{_prof.prof.cnt[555]++;/*I_*/defaultProps = new Properties();/*_I*/}/*I_*/
	    /*_I*/_prof.prof.cnt[556]++;/*I_*/InputStream in = defaultPropsURL.openStream();
	    /*_I*/{_prof.prof.cnt[557]++;/*I_*/defaultProps.load(in);/*_I*/}/*I_*/
 	    /*_I*/{_prof.prof.cnt[558]++;/*I_*/in.close();/*_I*/}/*I_*/
	    /*_I*/{_prof.prof.cnt[559]++;/*I_*/userProps = defaultProps;/*_I*/}/*I_*/
 	} catch (Exception ex) {
           /*_I*/{_prof.prof.cnt[560]++;/*I_*/System.err.println("Could not load properties.");/*_I*/}/*I_*/
 	}/*_I*/}/*I_*/

        //try to overload some properties with given command-line (html tag) Arguments
        /*_I*/_prof.prof.cnt[561]++;/*I_*/Enumeration allKeys = userProps.propertyNames();
        /*_I*/{_prof.prof.cnt[562]++;/*I_*/while (allKeys.hasMoreElements()) {
           /*_I*/_prof.prof.cnt[563]++;/*I_*/String key = (String)allKeys.nextElement();
           /*_I*/_prof.prof.cnt[564]++;/*I_*/String val = getParameter(key);
           //	    System.out.println("Got prop:"+key+":"+val);
           /*_I*/{_prof.prof.cnt[565]++;/*I_*/if (val != null  &&  val != "") {
              /*_I*/{_prof.prof.cnt[566]++;/*I_*/userProps.setProperty(key,val);/*_I*/}/*I_*/
           }/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
            
        //set Look&Feel
        /*_I*/_prof.prof.cnt[567]++;/*I_*/String lookAndFeel = "";
        /*_I*/{_prof.prof.cnt[568]++;/*I_*/try {
           /*_I*/{_prof.prof.cnt[569]++;/*I_*/lookAndFeel = userProps.getProperty("lookandfeel");/*_I*/}/*I_*/
           /*_I*/{_prof.prof.cnt[570]++;/*I_*/if (lookAndFeel.equals("windows")) {
              /*_I*/{_prof.prof.cnt[571]++;/*I_*/UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");/*_I*/}/*I_*/
           } else /*_I*/{_prof.prof.cnt[572]++;/*I_*/if (lookAndFeel.equals("motif")) {
              /*_I*/{_prof.prof.cnt[573]++;/*I_*/UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");/*_I*/}/*I_*/
           } else /*_I*/{_prof.prof.cnt[574]++;/*I_*/if (lookAndFeel.equals("mac")) {
              //Only available on macOS
              /*_I*/{_prof.prof.cnt[575]++;/*I_*/UIManager.setLookAndFeel("javax.swing.plaf.mac.MacLookAndFeel");/*_I*/}/*I_*/
           } else /*_I*/{_prof.prof.cnt[576]++;/*I_*/if (lookAndFeel.equals("metal")) {
              /*_I*/{_prof.prof.cnt[577]++;/*I_*/UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");/*_I*/}/*I_*/
           } else /*_I*/{_prof.prof.cnt[578]++;/*I_*/if (lookAndFeel.equals("nothing")) {
           } else {
               // default.
               /*_I*/{_prof.prof.cnt[579]++;/*I_*/UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());/*_I*/}/*I_*/
           }/*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*/
        } catch (Exception ex) {
           /*_I*/{_prof.prof.cnt[580]++;/*I_*/System.err.println("Error while setting Look&Feel"+lookAndFeel);/*_I*/}/*I_*/
        }/*_I*/}/*I_*/

 	//Layout everything
 	/*_I*/{_prof.prof.cnt[581]++;/*I_*/getContentPane().setLayout( new BorderLayout() );/*_I*/}/*I_*/

	/*_I*/{_prof.prof.cnt[582]++;/*I_*/c = new Controller(this);/*_I*/}/*I_*/

	/*_I*/{_prof.prof.cnt[583]++;/*I_*/if (Tools.safeEquals(getProperty("antialiasEdges"), "true")) {
           /*_I*/{_prof.prof.cnt[584]++;/*I_*/c.setAntialiasEdges(true);/*_I*/}/*I_*/ }/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[585]++;/*I_*/if (Tools.safeEquals(getProperty("antialiasAll"), "true")) {
           /*_I*/{_prof.prof.cnt[586]++;/*I_*/c.setAntialiasAll(true);/*_I*/}/*I_*/ }/*_I*/}/*I_*/

 	//Create the MenuBar
	/*_I*/{_prof.prof.cnt[587]++;/*I_*/menuBar = new MenuBar(c);/*_I*/}/*I_*/ //new MenuBar(c);
 	/*_I*/{_prof.prof.cnt[588]++;/*I_*/setJMenuBar(menuBar);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[589]++;/*I_*/c.setToolbarVisible(false);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[590]++;/*I_*/c.setMenubarVisible(false);/*_I*/}/*I_*/

	//Create the scroll pane.
		
	/*_I*/{_prof.prof.cnt[591]++;/*I_*/getContentPane().add( scrollPane, BorderLayout.CENTER );/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[592]++;/*I_*/getContentPane().add( status, BorderLayout.SOUTH );/*_I*/}/*I_*/

        /*_I*/{_prof.prof.cnt[593]++;/*I_*/SwingUtilities.updateComponentTreeUI(this);/*_I*/}/*I_*/ // Propagate LookAndFeel to JComponents

	/*_I*/{_prof.prof.cnt[594]++;/*I_*/c.changeToMode(getProperty("initial_mode"));/*_I*/}/*I_*/
    }
}
