/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: ArrowLinkAdapter.java,v 1.4 2003/12/07 21:00:19 christianfoltin Exp $*/

package freemind.modes;
import freemind.modes.LinkAdapter;
import freemind.main.FreeMindMain;

import java.awt.Point;

public abstract class ArrowLinkAdapter extends LinkAdapter implements MindMapArrowLink {

    /** the zero is the start point of the line;*/
    protected Point startInclination; 
    /** the zero is the start point of the line;*/
    protected Point endInclination; 
    protected String startArrow; 
    protected String endArrow;


    public ArrowLinkAdapter(MindMapNode source,MindMapNode target,FreeMindMain frame)  {
        super(source, target, frame, "standardlinkcolor", "standardlinkstyle");/*_I*/_prof.prof.cnt[6778]++;/*I_*//*_I*/_prof.prof.cnt[6779]++;/*I_*/
        /*_I*/{_prof.prof.cnt[6780]++;/*I_*/startArrow = "None";/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[6781]++;/*I_*/endArrow = "Default";/*_I*/}/*I_*/
    }

    public Point getStartInclination() {/*_I*/_prof.prof.cnt[6782]++;/*I_*/ /*_I*/{_prof.prof.cnt[6783]++;/*I_*/return startInclination;/*_I*/}/*I_*/ }
    public Point getEndInclination() {/*_I*/_prof.prof.cnt[6784]++;/*I_*/ /*_I*/{_prof.prof.cnt[6785]++;/*I_*/return endInclination;/*_I*/}/*I_*/ } 
    public String getStartArrow() {/*_I*/_prof.prof.cnt[6786]++;/*I_*/ /*_I*/{_prof.prof.cnt[6787]++;/*I_*/return startArrow;/*_I*/}/*I_*/ } 
    public String getEndArrow() {/*_I*/_prof.prof.cnt[6788]++;/*I_*/ /*_I*/{_prof.prof.cnt[6789]++;/*I_*/return endArrow;/*_I*/}/*I_*/ }

    public void  setStartInclination(Point startInclination) {/*_I*/_prof.prof.cnt[6790]++;/*I_*/  /*_I*/{_prof.prof.cnt[6791]++;/*I_*/this.startInclination=startInclination;/*_I*/}/*I_*/ }
    public void  setEndInclination(Point endInclination) {/*_I*/_prof.prof.cnt[6792]++;/*I_*/  /*_I*/{_prof.prof.cnt[6793]++;/*I_*/this.endInclination=endInclination;/*_I*/}/*I_*/ } 
    public void  setStartArrow(String startArrow) {/*_I*/_prof.prof.cnt[6794]++;/*I_*/  
        /*_I*/{_prof.prof.cnt[6795]++;/*I_*/if(startArrow == null || startArrow.toUpperCase().equals("NONE")) {
            /*_I*/{_prof.prof.cnt[6796]++;/*I_*/this.startArrow = "None";/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[6797]++;/*I_*/return;/*_I*/}/*I_*/
        } else /*_I*/{_prof.prof.cnt[6798]++;/*I_*/if(startArrow.toUpperCase().equals("DEFAULT")) {
            /*_I*/{_prof.prof.cnt[6799]++;/*I_*/this.startArrow = "Default";/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[6800]++;/*I_*/return;/*_I*/}/*I_*/
        }/*_I*/}/*I_*//*_I*/}/*I_*/
        // dont change:
        /*_I*/{_prof.prof.cnt[6801]++;/*I_*/System.err.println("Cannot set the start arrow type to " + startArrow);/*_I*/}/*I_*/
    } 
    public void  setEndArrow(String endArrow) {/*_I*/_prof.prof.cnt[6802]++;/*I_*/  
        /*_I*/{_prof.prof.cnt[6803]++;/*I_*/if(endArrow == null || endArrow.toUpperCase().equals("NONE")) {
            /*_I*/{_prof.prof.cnt[6804]++;/*I_*/this.endArrow = "None";/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[6805]++;/*I_*/return;/*_I*/}/*I_*/
        } else /*_I*/{_prof.prof.cnt[6806]++;/*I_*/if(endArrow.toUpperCase().equals("DEFAULT")) {
            /*_I*/{_prof.prof.cnt[6807]++;/*I_*/this.endArrow = "Default";/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[6808]++;/*I_*/return;/*_I*/}/*I_*/
        }/*_I*/}/*I_*//*_I*/}/*I_*/
        // dont change:
        /*_I*/{_prof.prof.cnt[6809]++;/*I_*/System.err.println("Cannot set the end arrow type to " + endArrow);/*_I*/}/*I_*/
    }

    public Object clone() {/*_I*/_prof.prof.cnt[6810]++;/*I_*/
        /*_I*/_prof.prof.cnt[6811]++;/*I_*/ArrowLinkAdapter arrowLink = (ArrowLinkAdapter) super.clone();
        // now replace the points:
        /*_I*/{_prof.prof.cnt[6812]++;/*I_*/arrowLink.startInclination = (startInclination==null)?null:new Point(startInclination.x, startInclination.y);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[6813]++;/*I_*/arrowLink.endInclination = (endInclination==null)?null:new Point(endInclination.x, endInclination.y);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[6814]++;/*I_*/arrowLink.startArrow = (startArrow==null)?null:new String(startArrow);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[6815]++;/*I_*/arrowLink.endArrow = (endArrow==null)?null:new String(endArrow);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[6816]++;/*I_*/return arrowLink;/*_I*/}/*I_*/
    }

}
