/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: EdgeAdapter.java,v 1.14 2003/11/16 22:15:15 christianfoltin Exp $*/

package freemind.modes;

import freemind.main.FreeMindMain;
import freemind.main.Tools;
import java.awt.Color;
import java.awt.Stroke;
import java.awt.BasicStroke;

public abstract class EdgeAdapter extends LineAdapter implements MindMapEdge {

	public static final int WIDTH_PARENT = -1;
	public static final int WIDTH_THIN = 0;

    public EdgeAdapter(MindMapNode target,FreeMindMain frame) {
        this(target, frame, "standardedgecolor", "standardedgestyle");/*_I*/_prof.prof.cnt[4982]++;/*I_*//*_I*/_prof.prof.cnt[4983]++;/*I_*/
    }

    /** For derived classes.*/
    protected  EdgeAdapter(MindMapNode target,FreeMindMain frame, String standardColorPropertyString, String standardStylePropertyString)  {
        super(target, frame, standardColorPropertyString, standardStylePropertyString);/*_I*/_prof.prof.cnt[4984]++;/*I_*//*_I*/_prof.prof.cnt[4985]++;/*I_*/
        /*_I*/{_prof.prof.cnt[4986]++;/*I_*/NORMAL_WIDTH = WIDTH_PARENT;/*_I*/}/*I_*/
    }

    //
    // Attributes
    //

    public Color getColor() {/*_I*/_prof.prof.cnt[4987]++;/*I_*/
        /*_I*/{_prof.prof.cnt[4988]++;/*I_*/if(color==null) {
            /*_I*/{_prof.prof.cnt[4989]++;/*I_*/if (getTarget().isRoot()) {
                /*_I*/_prof.prof.cnt[4990]++;/*I_*/String stdcolor = getFrame().getProperty(standardColorPropertyString);
                /*_I*/{_prof.prof.cnt[4991]++;/*I_*/if (stdcolor.length() == 7) {
                    /*_I*/{_prof.prof.cnt[4992]++;/*I_*/return Tools.xmlToColor(stdcolor);/*_I*/}/*I_*/
                }/*_I*/}/*I_*/
                /*_I*/{_prof.prof.cnt[4993]++;/*I_*/return Color.blue;/*_I*/}/*I_*/
            }/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[4994]++;/*I_*/return getSource().getEdge().getColor();/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[4995]++;/*I_*/return color;/*_I*/}/*I_*/
    }

    public int getWidth() {/*_I*/_prof.prof.cnt[4996]++;/*I_*/
        /*_I*/{_prof.prof.cnt[4997]++;/*I_*/if (width==WIDTH_PARENT) {
            /*_I*/{_prof.prof.cnt[4998]++;/*I_*/if (getTarget().isRoot()) {
                /*_I*/{_prof.prof.cnt[4999]++;/*I_*/return WIDTH_THIN;/*_I*/}/*I_*/ }/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[5000]++;/*I_*/return getSource().getEdge().getWidth();/*_I*/}/*I_*/ }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[5001]++;/*I_*/return width;/*_I*/}/*I_*/ }

    public Stroke getStroke() {/*_I*/_prof.prof.cnt[5002]++;/*I_*/
        /*_I*/{_prof.prof.cnt[5003]++;/*I_*/if (width==WIDTH_THIN)
            /*_I*/{_prof.prof.cnt[5004]++;/*I_*/return null;/*_I*/}/*I_*//*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[5005]++;/*I_*/if(stroke==null) {
            /*_I*/{_prof.prof.cnt[5006]++;/*I_*/if (getTarget().isRoot()) {
                /*_I*/{_prof.prof.cnt[5007]++;/*I_*/return null;/*_I*/}/*I_*/
            }/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[5008]++;/*I_*/return getSource().getEdge().getStroke();/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[5009]++;/*I_*/return stroke;/*_I*/}/*I_*/
    }
		
    public void setWidth(int width) {/*_I*/_prof.prof.cnt[5010]++;/*I_*/
        /*_I*/{_prof.prof.cnt[5011]++;/*I_*/this.width = width;/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[5012]++;/*I_*/stroke = ((width==WIDTH_PARENT) || (width==WIDTH_THIN)) ? null :
            new BasicStroke(getWidth(),BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER);/*_I*/}/*I_*/ }

    public String getStyle() {/*_I*/_prof.prof.cnt[5013]++;/*I_*/
        /*_I*/{_prof.prof.cnt[5014]++;/*I_*/if(style==null) {
            /*_I*/{_prof.prof.cnt[5015]++;/*I_*/if (getTarget().isRoot()) {
                /*_I*/{_prof.prof.cnt[5016]++;/*I_*/return getFrame().getProperty(standardStylePropertyString);/*_I*/}/*I_*/
            }/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[5017]++;/*I_*/return getSource().getEdge().getStyle();/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[5018]++;/*I_*/return style;/*_I*/}/*I_*/
    }

    ///////////
    // Private Methods
    /////////

    private MindMapNode getSource() {/*_I*/_prof.prof.cnt[5019]++;/*I_*/
        /*_I*/{_prof.prof.cnt[5020]++;/*I_*/return target.getParentNode();/*_I*/}/*I_*/
    }
}
