/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: LinkAdapter.java,v 1.3 2003/11/29 17:12:33 christianfoltin Exp $*/

package freemind.modes;
import freemind.modes.LineAdapter;
import freemind.main.FreeMindMain;

public abstract class LinkAdapter extends LineAdapter implements MindMapLink {

    String destinationLabel;
    String referenceText;
    MindMapNode source;

    public LinkAdapter(MindMapNode source,MindMapNode target,FreeMindMain frame)  {
        this(source,target, frame, "standardlinkcolor", "standardlinkstyle");/*_I*/_prof.prof.cnt[7115]++;/*I_*//*_I*/_prof.prof.cnt[7116]++;/*I_*/
    }

    /** For derived classes.*/
    protected  LinkAdapter(MindMapNode source,MindMapNode target,FreeMindMain frame, String standardColorPropertyString, String standardStylePropertyString)  {
        super(target, frame, standardColorPropertyString, standardStylePropertyString);/*_I*/_prof.prof.cnt[7117]++;/*I_*//*_I*/_prof.prof.cnt[7118]++;/*I_*/
        /*_I*/{_prof.prof.cnt[7119]++;/*I_*/this.source=source;/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[7120]++;/*I_*/destinationLabel = null;/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[7121]++;/*I_*/referenceText = null;/*_I*/}/*I_*/
    }

    public String getDestinationLabel() {/*_I*/_prof.prof.cnt[7122]++;/*I_*/ /*_I*/{_prof.prof.cnt[7123]++;/*I_*/return destinationLabel;/*_I*/}/*I_*/ }
    public String getReferenceText(){/*_I*/_prof.prof.cnt[7124]++;/*I_*/ /*_I*/{_prof.prof.cnt[7125]++;/*I_*/return referenceText;/*_I*/}/*I_*/ }
    public MindMapNode getSource() {/*_I*/_prof.prof.cnt[7126]++;/*I_*/ /*_I*/{_prof.prof.cnt[7127]++;/*I_*/return source;/*_I*/}/*I_*/}
    
    public void setSource(MindMapNode source) {/*_I*/_prof.prof.cnt[7128]++;/*I_*//*_I*/{_prof.prof.cnt[7129]++;/*I_*/this.source=source;/*_I*/}/*I_*/}
    public void setDestinationLabel(String destinationLabel) {/*_I*/_prof.prof.cnt[7130]++;/*I_*/ /*_I*/{_prof.prof.cnt[7131]++;/*I_*/this.destinationLabel = destinationLabel;/*_I*/}/*I_*/ }
    public void setReferenceText(String referenceText) {/*_I*/_prof.prof.cnt[7132]++;/*I_*/ /*_I*/{_prof.prof.cnt[7133]++;/*I_*/this.referenceText = referenceText;/*_I*/}/*I_*/ }

//     public Object clone() {
//         try {
//             return super.clone();
//         } catch(java.lang.CloneNotSupportedException e) {
//             return null;
//         }
//     }


}
