/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: FileController.java,v 1.11 2003/11/03 11:00:13 sviles Exp $*/

package freemind.modes.filemode;

import freemind.modes.Mode;
import freemind.modes.MindMap;
import freemind.modes.MapAdapter;
import freemind.modes.MindMapNode;
import freemind.modes.ControllerAdapter;
import java.io.File;
import java.awt.event.ActionEvent;
import javax.swing.*;

public class FileController extends ControllerAdapter {

    Action find = new FindAction();
    Action findNext = new FindNextAction();

    Action newMap = new NewMapAction(this);
    Action center = new CenterAction();
    Action openPath = new OpenPathAction();

    private JPopupMenu popupmenu = new FilePopupMenu(this);


    public FileController(Mode mode) {
	super(mode);/*_I*/_prof.prof.cnt[3184]++;/*I_*//*_I*/_prof.prof.cnt[3185]++;/*I_*/
    }

    public MapAdapter newModel() {/*_I*/_prof.prof.cnt[3186]++;/*I_*/
	/*_I*/{_prof.prof.cnt[3187]++;/*I_*/return new FileMapModel(getFrame());/*_I*/}/*I_*/
    }

    public MindMapNode newNode() {/*_I*/_prof.prof.cnt[3188]++;/*I_*/
	/*_I*/_prof.prof.cnt[3189]++;/*I_*/File newNode = new File(((FileNodeModel)getSelected()).getFile(),"new_Directory");
	/*_I*/{_prof.prof.cnt[3190]++;/*I_*/newNode.mkdir();/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[3191]++;/*I_*/return new FileNodeModel(newNode,getFrame());/*_I*/}/*I_*/
    }

    public JMenu getEditMenu() {/*_I*/_prof.prof.cnt[3192]++;/*I_*/
	/*_I*/_prof.prof.cnt[3193]++;/*I_*/JMenu editMenu = new JMenu();
        /*_I*/{_prof.prof.cnt[3194]++;/*I_*/add(editMenu, find, "keystroke_find");/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[3195]++;/*I_*/add(editMenu, findNext, "keystroke_find_next");/*_I*/}/*I_*/ 
        /*_I*/{_prof.prof.cnt[3196]++;/*I_*/add(editMenu, openPath);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[3197]++;/*I_*/return editMenu;/*_I*/}/*I_*/ }

    public JPopupMenu getPopupMenu() {/*_I*/_prof.prof.cnt[3198]++;/*I_*/
      /*_I*/{_prof.prof.cnt[3199]++;/*I_*/return this.popupmenu;/*_I*/}/*I_*/
    }
    //-----------------------------------------------------------------------------------

    // Private
    // 

    private MindMap getModel() {/*_I*/_prof.prof.cnt[3200]++;/*I_*/
 	/*_I*/{_prof.prof.cnt[3201]++;/*I_*/return (MindMap)getController().getModel();/*_I*/}/*I_*/
    }

    private MindMapNode getSelected() {/*_I*/_prof.prof.cnt[3202]++;/*I_*/
	/*_I*/{_prof.prof.cnt[3203]++;/*I_*/if (getView() != null) {
	    /*_I*/{_prof.prof.cnt[3204]++;/*I_*/return (MindMapNode)getView().getSelected().getModel();/*_I*/}/*I_*/
	} else {
	    /*_I*/{_prof.prof.cnt[3205]++;/*I_*/return null;/*_I*/}/*I_*/
	}/*_I*/}/*I_*/
    }
    
    private class CenterAction extends AbstractAction {
	CenterAction() {
	    super(getController().getResourceString("center"));/*_I*/_prof.prof.cnt[3206]++;/*I_*//*_I*/_prof.prof.cnt[3207]++;/*I_*/
	}
	public void actionPerformed(ActionEvent e) {/*_I*/_prof.prof.cnt[3208]++;/*I_*/
	    /*_I*/{_prof.prof.cnt[3209]++;/*I_*/if (getSelected() != null) {
		/*_I*/_prof.prof.cnt[3210]++;/*I_*/MindMap map = new FileMapModel(((FileNodeModel)getSelected()).getFile(), getFrame());
		/*_I*/{_prof.prof.cnt[3211]++;/*I_*/newMap(map);/*_I*/}/*I_*/
	    }/*_I*/}/*I_*/
	}
    }

    private class OpenPathAction extends AbstractAction {
	OpenPathAction() {
	    super(getController().getResourceString("open"));/*_I*/_prof.prof.cnt[3212]++;/*I_*//*_I*/_prof.prof.cnt[3213]++;/*I_*/
	}
	public void actionPerformed(ActionEvent e) {/*_I*/_prof.prof.cnt[3214]++;/*I_*/
           /*_I*/_prof.prof.cnt[3215]++;/*I_*/String inputValue = JOptionPane.showInputDialog
              (getText("open"), "");
           /*_I*/{_prof.prof.cnt[3216]++;/*I_*/if (inputValue != null) {
              /*_I*/_prof.prof.cnt[3217]++;/*I_*/File newCenter = new File(inputValue);
              /*_I*/{_prof.prof.cnt[3218]++;/*I_*/if (newCenter.exists()) { // and is a folder
		/*_I*/_prof.prof.cnt[3219]++;/*I_*/MindMap map = new FileMapModel(newCenter, getFrame());
		/*_I*/{_prof.prof.cnt[3220]++;/*I_*/newMap(map);/*_I*/}/*I_*/
              }/*_I*/}/*I_*/
           }/*_I*/}/*I_*/
        }
    }

}
