/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: SchemeController.java,v 1.10 2003/11/03 11:00:21 sviles Exp $*/

package freemind.modes.schememode;

import java.awt.event.ActionEvent;
import java.io.File;
import java.util.StringTokenizer;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;

import freemind.modes.ControllerAdapter;
import freemind.modes.MapAdapter;
import freemind.modes.MindMap;
import freemind.modes.MindMapNode;
import freemind.modes.Mode;

public class SchemeController extends ControllerAdapter {

    Action newMap = new NewMapAction(this);
    Action open = new OpenAction(this);
    Action save = new SaveAction(this);
    Action saveAs = new SaveAsAction(this);
    Action evaluate = new EvaluateAction();
    Action edit = new EditAction();
    Action addNew = new NewChildWithoutFocusAction();
    Action remove = new RemoveAction();
    Action toggleFolded = new ToggleFoldedAction();
    private JPopupMenu popupmenu = new SchemePopupMenu(this);

    public SchemeController(Mode mode) {
	super(mode);/*_I*/_prof.prof.cnt[4804]++;/*I_*//*_I*/_prof.prof.cnt[4805]++;/*I_*/
    }

    public MapAdapter newModel() {/*_I*/_prof.prof.cnt[4806]++;/*I_*/
	/*_I*/{_prof.prof.cnt[4807]++;/*I_*/return new SchemeMapModel(getFrame());/*_I*/}/*I_*/
    }

    public MindMapNode newNode() {/*_I*/_prof.prof.cnt[4808]++;/*I_*/
	/*_I*/{_prof.prof.cnt[4809]++;/*I_*/return new SchemeNodeModel(getFrame());/*_I*/}/*I_*/
    }

    //private
    private MindMap getModel() {/*_I*/_prof.prof.cnt[4810]++;/*I_*/
 	/*_I*/{_prof.prof.cnt[4811]++;/*I_*/return (MindMap)getController().getModel();/*_I*/}/*I_*/
    }

    private MindMapNode getSelected() {/*_I*/_prof.prof.cnt[4812]++;/*I_*/
	/*_I*/{_prof.prof.cnt[4813]++;/*I_*/if (getView() != null) {
	    /*_I*/{_prof.prof.cnt[4814]++;/*I_*/return (MindMapNode)getView().getSelected().getModel();/*_I*/}/*I_*/
	} else {
	    /*_I*/{_prof.prof.cnt[4815]++;/*I_*/return null;/*_I*/}/*I_*/
	}/*_I*/}/*I_*/
    }


	public boolean saveAs() {/*_I*/_prof.prof.cnt[4816]++;/*I_*/
	    /*_I*/_prof.prof.cnt[4817]++;/*I_*/java.io.File ioDir = new java.io.File( "input_files" );
	    /*_I*/_prof.prof.cnt[4818]++;/*I_*/javax.swing.JFileChooser chooser = new JFileChooser(ioDir);
// 		if ((getMap().getFile() != null) && (getMap().getFile().getParentFile() != null)) {
// 			chooser = new JFileChooser(getMap().getFile().getParentFile());
// 		} else {
// 			chooser = new JFileChooser();
// 		}
		//chooser.setLocale(currentLocale);
		/*_I*/{_prof.prof.cnt[4819]++;/*I_*/if (getFileFilter() != null) {
			/*_I*/{_prof.prof.cnt[4820]++;/*I_*/chooser.addChoosableFileFilter(getFileFilter());/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
		/*_I*/_prof.prof.cnt[4821]++;/*I_*/int returnVal = chooser.showSaveDialog(getView());
		/*_I*/{_prof.prof.cnt[4822]++;/*I_*/if (returnVal==JFileChooser.APPROVE_OPTION) {//ok pressed
			/*_I*/_prof.prof.cnt[4823]++;/*I_*/File f = chooser.getSelectedFile();
			//Force the extension to be .mm
			//      String ext = Tools.getExtension(f.getName());
			//      if(!ext.equals("mm")) {
			//          f = new File(f.getParent(),f.getName()+".mm");
			//      }
			/*_I*/{_prof.prof.cnt[4824]++;/*I_*/save(f);/*_I*/}/*I_*/
			//Update the name of the map
			/*_I*/{_prof.prof.cnt[4825]++;/*I_*/updateMapModuleName();/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[4826]++;/*I_*/return true;/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[4827]++;/*I_*/return false;/*_I*/}/*I_*/
	}


    public JPopupMenu getPopupMenu() {/*_I*/_prof.prof.cnt[4828]++;/*I_*/
      /*_I*/{_prof.prof.cnt[4829]++;/*I_*/return this.popupmenu;/*_I*/}/*I_*/
    }

    private class EvaluateAction extends AbstractAction {
	EvaluateAction() {
	    super(getController().getResourceString("scheme_evaluate"));/*_I*/_prof.prof.cnt[4830]++;/*I_*//*_I*/_prof.prof.cnt[4831]++;/*I_*/
	}
	public void actionPerformed(ActionEvent e) {/*_I*/_prof.prof.cnt[4832]++;/*I_*/
	    /*_I*/_prof.prof.cnt[4833]++;/*I_*/String rawCode = ((SchemeMapModel)getMap()).getCode().trim();
	    /*_I*/{_prof.prof.cnt[4834]++;/*I_*/System.out.println(rawCode);/*_I*/}/*I_*/
	    /*_I*/_prof.prof.cnt[4835]++;/*I_*/StringTokenizer code = new StringTokenizer(rawCode,",");
	    /*_I*/_prof.prof.cnt[4836]++;/*I_*/String output = "Output: \n";
	    //	    while(code.hasMoreTokens()) {
	    //		output = output + (SI.eval(code.nextToken()).toString())+"\n";
	    //	    }
	    /*_I*/{_prof.prof.cnt[4837]++;/*I_*/JOptionPane.showMessageDialog(getView(),output);/*_I*/}/*I_*/
	}
    }
}
