/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: ForkNodeView.java,v 1.10 2003/11/03 11:00:24 sviles Exp $*/

package freemind.view.mindmapview;

import freemind.modes.MindMapNode;
import java.awt.*;

/**
 * This class represents a single Fork-Style Node of a MindMap
 * (in analogy to TreeCellRenderer).
 */
public class ForkNodeView extends NodeView {


    //
    // Constructors
    //
    
    public ForkNodeView(MindMapNode model, MapView map) {
	super(model,map);/*_I*/_prof.prof.cnt[2802]++;/*I_*//*_I*/_prof.prof.cnt[2803]++;/*I_*/
    }

    public Dimension getPreferredSize() {/*_I*/_prof.prof.cnt[2804]++;/*I_*/
	/*_I*/{_prof.prof.cnt[2805]++;/*I_*/return new Dimension(super.getPreferredSize().width,
                             super.getPreferredSize().height + 3 + getEdge().getRealWidth());/*_I*/}/*I_*/
    }	
  
    /**
     * Paints the node
     */
    public void paint(Graphics graphics) {/*_I*/_prof.prof.cnt[2806]++;/*I_*/
	/*_I*/_prof.prof.cnt[2807]++;/*I_*/Graphics2D g = (Graphics2D)graphics;
	/*_I*/_prof.prof.cnt[2808]++;/*I_*/Dimension size = getSize();
	//Dimension size = getPreferredSize();

	/*_I*/{_prof.prof.cnt[2809]++;/*I_*/if (this.getModel()==null) /*_I*/{_prof.prof.cnt[2810]++;/*I_*/return;/*_I*/}/*I_*//*_I*/}/*I_*/

        /*_I*/{_prof.prof.cnt[2811]++;/*I_*/paintSelected(g, size);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[2812]++;/*I_*/paintDragOver(g, size);/*_I*/}/*I_*/

        /*_I*/_prof.prof.cnt[2813]++;/*I_*/int edgeWidth = getEdge().getRealWidth();

	//Draw a standard node
        /*_I*/{_prof.prof.cnt[2814]++;/*I_*/setRendering(g);/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[2815]++;/*I_*/g.setColor(getEdge().getColor());/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[2816]++;/*I_*/g.setStroke(getEdge().getStroke());/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[2817]++;/*I_*/g.drawLine(0,          size.height-edgeWidth/2-1,
                   size.width, size.height-edgeWidth/2-1);/*_I*/}/*I_*/
   
	/*_I*/{_prof.prof.cnt[2818]++;/*I_*/super.paint(g);/*_I*/}/*I_*/
    }
}









